.gba
.open "zm_u.gba","zm_u_colorfulHUD.gba",       0x8000000
.definelabel Freespace, filesize("zm_u.gba") + 	0x8000000

.org 0x832F2C8
	.import "colorfulHUD_digits.gfx"

.org 0x8052D78
	ldr		r0,=hudcolorsuperhijack
	mov		r15,r0
.pool

.org 0x8052DE8
	nop	;preent overwritting graphics offset

.org 0x8052E50
	ldr		r0,=hudcolorpowerbombhijack
	mov		r15,r0
.pool

.org 0x8052EC0
	nop	;preent overwritting graphics offset

	
.org 0x805272C
	ldr     r6,=6010A00h
	ldr     r2,=3000904h
	mov     r9,r2

MaxEnergy:
	mov     r5,0h
	ldr     r0,=3001530h
	ldrh    r4,[r0]
	mov     r10,r4
	ldr     r7,=3000908h
	ldrb    r0,[r7,3h]
	mov     r1,0FAh
	lsl     r1,r1,2h
	mul     r0,r1
	ldrb    r2,[r7,2h]
	mov     r1,64h
	mul     r2,r1
	add     r0,r0,r2
	ldrb    r2,[r7,1h]
	mov     r1,0Ah
	mul     r2,r1
	add     r0,r0,r2
	ldrb    r2,[r7]
	add     r0,r0,r2
	cmp     r0,r4
	beq     CurrentEnergy
	mov     r5,1h

MaxThousands:
	add     r0,r4,0
	mov     r1,0FAh
	lsl     r1,r1,2h
	bl      808ADE0h
	lsl     r0,r0,18h
	lsr     r0,r0,18h
	mov     r1,0Ah
	bl      808AE58h
	lsl     r0,r0,18h
	lsr     r1,r0,18h
	strb    r1,[r7,3h]

MaxHundreds:
	add     r0,r4,0
	mov     r1,64h
	bl      808ADE0h
	lsl     r0,r0,18h
	lsr     r0,r0,18h
	mov     r1,0Ah
	bl      808AE58h
	lsl     r0,r0,18h
	lsr     r1,r0,18h
	strb    r1,[r7,2h]

MaxTens:
	add     r0,r4,0
	mov     r1,0Ah
	bl      808ADE0h
	lsl     r0,r0,18h
	lsr     r0,r0,18h
	mov     r1,0Ah
	bl      808AE58h
	lsl     r0,r0,18h
	lsr     r1,r0,18h
	strb    r1,[r7,1h]

MaxOnes:
	add     r0,r4,0
	mov     r1,0Ah
	bl      808AE58h
	lsl     r0,r0,18h
	lsr     r1,r0,18h
	strb    r1,[r7]

CurrentEnergy:
	add     r0,r4,0
	mov     r1,64h
	bl      808ADE0h
	lsl     r0,r0,18h
	lsr     r0,r0,18h
	mov     r8,r0
	ldr     r0,=3001530h
	ldrh    r7,[r0,6h]
	mov     r4,r9
	ldrb    r0,[r4,3h]
	mov     r1,0FAh
	lsl     r1,r1,2h
	mul     r0,r1
	ldrb    r2,[r4,2h]
	mov     r1,64h
	mul     r2,r1
	add     r0,r0,r2
	ldrb    r2,[r4,1h]
	mov     r1,0Ah
	mul     r2,r1
	add     r0,r0,r2
	ldrb    r2,[r4]
	add     r0,r0,r2
	cmp     r0,r7
	beq     CheckNeedUpdate
	mov     r5,1h

CurrentThousands:
	add     r0,r7,0
	mov     r1,0FAh
	lsl     r1,r1,2h
	bl      808ADE0h
	lsl     r0,r0,18h
	lsr     r0,r0,18h
	mov     r1,0Ah
	bl      808AE58h
	lsl     r0,r0,18h
	lsr     r1,r0,18h
	strb    r1,[r4,3h]

CurrentHundreds:
	add     r0,r7,0
	mov     r1,64h
	bl      808ADE0h
	lsl     r0,r0,18h
	lsr     r0,r0,18h
	mov     r1,0Ah
	bl      808AE58h
	lsl     r0,r0,18h
	lsr     r1,r0,18h
	strb    r1,[r4,2h]

CurrentTens:
	add     r0,r7,0
	mov     r1,0Ah
	bl      808ADE0h
	lsl     r0,r0,18h
	lsr     r0,r0,18h
	mov     r1,0Ah
	bl      808AE58h
	lsl     r0,r0,18h
	lsr     r1,r0,18h
	strb    r1,[r4,1h]
	ldr     r2,=40000D4h
	lsl     r0,r1,5h
	cmp		  r7,1Dh
	bhi		  @@notlow
@@lowhealth:
	ldr		  r1,=832FEC8h  ; red tens place digits
	b		    @@continue
@@notlow:
	ldr		  r1,=8330948h ;vanilla tens place digits
@@continue:
	add		  r0,r0,r1
	str     r0,[r2]
	str     r6,[r2,4h]
	ldr     r0,=80000010h
	str     r0,[r2,8h]

CurrentOnes:
	add     r0,r7,0
	mov     r1,0Ah
	bl      808AE58h
	lsl     r0,r0,18h
	lsr     r1,r0,18h
	strb    r1,[r4]
	ldr     r2,=40000D4h
	lsl     r0,r1,5h
	cmp		  r7,1Dh
	bhi		  @@notlow
@@lowhealth:
	ldr		  r1,=8330008h  ; red ones place digits
	b		    @@continue
@@notlow:
	ldr		  r1,=8330A88h ;vanilla ones place digits
@@continue:
	add		  r0,r0,r1
	str     r0,[r2]
	add     r0,r6,0
	add     r0,20h
	str     r0,[r2,4h]
	ldr     r0,=80000010h
	str     r0,[r2,8h]
	
CheckNeedUpdate:
	add     r0,r7,0
	mov     r1,64h
	bl      808ADE0h
	lsl     r0,r0,18h
	lsr     r4,r0,18h
	ldr     r1,=3001530h
	cmp     r5,0h
	bne     UpdateNeeded
	b       8052A1Eh
	.pool
UpdateNeeded:
	mov     r0,0h
	cmp     r7,1Dh
	bhi     SetLowHealthFlag
	mov     r0,1h
SetLowHealthFlag:
	strb    r0,[r1,11h]
	mov     r0,r8
	cmp     r0,0Ch
	bls     UpdateETanks
	b       8052A1Eh
UpdateETanks:
	lsl     r0,r0,2h
	ldr     r1,=80528D4h
	add     r0,r0,r1
	ldr     r0,[r0]
	mov     r15,r0
	.pool

.org Freespace
hudcolorsuperhijack:
	lsr   r2,r2,10h
	mov   r3,0h
	mov   r12,r3
	ldr   r7,=300091Ch
	ldr   r6,=832F2C8h
	ldr		r0,=460h
	cmp		r2,r0
	bne		@@return
	ldr   r0,=600h
	add   r6,r0,r6
@@return:
	ldr		r0,=0x8052D82
	mov		r15,r0

.pool

hudcolorpowerbombhijack:
	lsr   r2,r2,10h
	mov   r3,0h
	mov   r12,r3
	ldr   r7,=300091Ch
	ldr   r6,=832F2C8h
	ldr		r0,=460h
	cmp		r2,r0
	bne		@@return
	ldr   r0,=780h
	add   r6,r0,r6
@@return:
	ldr		r0,=0x8052E5A
	mov		r15,r0

.pool

.close